from typing import Dict


class Context:
    def __init__(self, use_case: str, context: str, user_source: str, volume_source: str,
                 conversion: float, certainty: float, cutoff: float, bias_negative: float, bias_positive: float):
        self.use_case = use_case
        self.context = context
        self.user_source = user_source
        self.volume_source = volume_source
        self.conversion = conversion
        self.certainty = certainty
        self.cutoff = cutoff
        self.bias_negative = bias_negative
        self.bias_positive = bias_positive

    def to_serializable_dict(self):
        return {
            "use_case": self.use_case,
            "context": self.context,
            "user_source": self.user_source,
            "volume_source": self.volume_source,
            "conversion": self.conversion,
            "certainty": self.certainty,
            "cutoff": self.cutoff,
            "bias_negative": self.bias_negative,
            "bias_positive": self.bias_positive
        }

    @staticmethod
    def from_serializable_dict(data: Dict):
        return Context(
            data["use_case"],
            data["context"],
            data["user_source"],
            data["volume_source"],
            data["conversion"],
            data["certainty"],
            data["cutoff"],
            data["bias_negative"],
            data["bias_positive"],
        )
